var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ShContextService } from './sh-context-service';
import { Directive, Input, HostListener, Output, EventEmitter } from "@angular/core";
import { ShContextOverlayComponent } from './sh-context-overlay.component';
import { ShContextMenuComponent } from "./sh-context-menu.component";
import { InjectionService } from "./injector.service";
var ShContextMenuDirective = /** @class */ (function () {
    function ShContextMenuDirective(ctxService, injectionService) {
        this.ctxService = ctxService;
        this.injectionService = injectionService;
        this.onBeforeMenuOpen = new EventEmitter();
    }
    ShContextMenuDirective.prototype.onClick = function (event) {
        var _this = this;
        this.options = this.ctxService.setOptions(this.options);
        this.closeMenu();
        if (this.contextMenuIsEmpty()) {
            return;
        }
        if (this.onBeforeMenuOpen.observers.length > 0) {
            this.onBeforeMenuOpen.emit({
                event: event,
                items: this.menuItems,
                open: function (modifiedItems) {
                    if (modifiedItems === void 0) { modifiedItems = _this.menuItems; }
                    return _this.createMenu(event, modifiedItems);
                }
            });
        }
        else {
            this.createMenu(event);
        }
        return false;
    };
    ShContextMenuDirective.prototype.createMenu = function (event, items) {
        if (items === void 0) { items = this.menuItems; }
        this.overlayComponent = this.createOverlayComponent();
        this.ctxComponent = this.createContextComponent();
        this.registerBindings(items);
        this.registerEvents();
        this.setLocation(event);
    };
    ShContextMenuDirective.prototype.registerEvents = function () {
        var _this = this;
        this.ctxComponent.instance.onClose.subscribe(function () {
            _this.closeMenu();
        });
        this.overlayComponent.instance.onClick.subscribe(function () {
            _this.closeMenu();
        });
    };
    ShContextMenuDirective.prototype.registerBindings = function (menuItems) {
        this.ctxComponent.instance.items = menuItems;
        this.ctxComponent.instance.dataContext = this.dataContext;
    };
    ShContextMenuDirective.prototype.createContextComponent = function () {
        return this.injectionService.appendComponent(ShContextMenuComponent);
    };
    ShContextMenuDirective.prototype.createOverlayComponent = function () {
        return this.injectionService.appendComponent(ShContextOverlayComponent);
    };
    ShContextMenuDirective.prototype.setLocation = function (event) {
        var clientX = event.clientX, clientY = event.clientY;
        this.ctxComponent.instance.position = {
            top: clientY,
            left: clientX
        };
    };
    ShContextMenuDirective.prototype.closeMenu = function () {
        if (this.ctxComponent)
            this.ctxComponent.destroy();
        if (this.overlayComponent)
            this.overlayComponent.destroy();
    };
    ShContextMenuDirective.prototype.contextMenuIsEmpty = function () {
        return !this.menuItems || this.menuItems.length === 0;
    };
    __decorate([
        Input('sh-context'),
        __metadata("design:type", Array)
    ], ShContextMenuDirective.prototype, "menuItems", void 0);
    __decorate([
        Input('sh-data-context'),
        __metadata("design:type", Object)
    ], ShContextMenuDirective.prototype, "dataContext", void 0);
    __decorate([
        Input('sh-options'),
        __metadata("design:type", Object)
    ], ShContextMenuDirective.prototype, "options", void 0);
    __decorate([
        Output('onBeforeMenuOpen'),
        __metadata("design:type", Object)
    ], ShContextMenuDirective.prototype, "onBeforeMenuOpen", void 0);
    __decorate([
        HostListener('contextmenu', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [MouseEvent]),
        __metadata("design:returntype", void 0)
    ], ShContextMenuDirective.prototype, "onClick", null);
    ShContextMenuDirective = __decorate([
        Directive({
            selector: '[sh-context]'
        }),
        __metadata("design:paramtypes", [ShContextService,
            InjectionService])
    ], ShContextMenuDirective);
    return ShContextMenuDirective;
}());
export { ShContextMenuDirective };
//# sourceMappingURL=sh-context-menu.directive.js.map